#ifndef apache20_defined
#define apache20_defined

#include "apr_strings.h"
#include "apr_lib.h"
#include "apr_hash.h"
#include "apr_optional.h"
#define APR_WANT_STRFUNC
#include "apr_want.h"
#include "apr_tables.h"
#include "apr_pools.h"

//#include "apr_thread_mutex.h"

#include "ap_config.h"

/*static void nufw_log_error(char *file, 
                      int line, 
                      int level, 
                      const server_rec *s, 
                      const char *fmt, 
                      ...) 
                      __attribute__ ((format (printf, 5,6)));
*/
static inline void nufw_log_error(char *file, 
                             int line, 
                             int level, 
                             const server_rec *s, 
                             const char *fmt, 
                             ...)
{
  static char buff[MAX_STRING_LEN];
  va_list args;
  va_start(args, fmt);
  apr_vsnprintf(buff,MAX_STRING_LEN, fmt,args);
  ap_log_error(file,line,level,0,s,"%s",buff);
  va_end(args);
}

static inline void nufw_log_rerror(char *file, 
                             int line, 
                             int level, 
                             const request_rec *r, 
                             const char *fmt, 
                             ...)
{
  static char buff[MAX_STRING_LEN];
  va_list args;
  va_start(args, fmt);
  apr_vsnprintf(buff,MAX_STRING_LEN, fmt,args);
  ap_log_rerror(file,line,level,0,r,"%s",buff);
  va_end(args);
}
#endif //apache20_defined
