/* This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2
 * of the License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.*/

#include "nufw_declarations.h"

#define LDAPCACHE_NULL_CHAR -1
#define LDAP_CACHE_UID_ALREADY_IN -2
#define LDAP_CACHE_COULDNT_STRNDUP -3
#define LDAP_CACHE_COULDNT_MALLOC -4

typedef struct _ldap_uid_cache{
    unsigned long uid;
    char *user;
    struct _ldap_uid_cache *next;
}ldap_uid_cache;

typedef struct _luc_cache_list{
    char *host;
    char *binddn;
    char *base;
    unsigned int port;
    ldap_uid_cache *luc;
    struct _luc_cache_list *next;
} luc_cache_list;


int check_ldap_uid_cache(apr_pool_t *ourpool,
                         luc_cache_list *luc,
                         char **user,
                         unsigned long result,
                         char *host,
                         unsigned port,
                         char *binddn,
                         char *base);
int add_ldap_uid_cache(luc_cache_list **luc,
                       char *user,
                       unsigned long result,
                       char *host,
                       unsigned port,
                       char *binddn,
                       char *base,
                       int max);
